// PlatformMemory.h 
// Copyright  1985-96 by Apple Computer, Inc. All rights reserved.

#ifndef PLATFORMMEMORY_H
#define PLATFORMMEMORY_H

// MacApp

#ifndef __PASCALSTRING__
#include "PascalString.h"
#endif

#ifndef __UFAILURE__
#include "UFailure.h"
#endif

// Toolbox

#ifndef __MEMORY__
#include <Memory.h>
#endif

// ANSI

#ifndef __STDDEF__
#include <stddef.h>
#endif


//========================================================================================
// Constants
//========================================================================================

#if qDebug
#define DEBUG 1
#endif

extern short gOHRemainingIncrements;	//added by C. Kopala 6/21/96

//========================================================================================
// Debugging
//========================================================================================

void PLATFORM_ASSERT(Boolean condition);

inline void PLATFORM_DEBUGGER_STRING(const CStr255& string)
{
	ProgramBreak(string);
}

void PLATFORM_PRINT_STRING(const char* string);

//========================================================================================
// Global function definitions
//========================================================================================

//----------------------------------------------------------------------------------------
// PlatformAllocateBlock
//----------------------------------------------------------------------------------------

void *PlatformAllocateBlock(size_t size);
// Definition moved to PlatformMemory.cp

//----------------------------------------------------------------------------------------
// PlatformFreeBlock
//----------------------------------------------------------------------------------------

inline void PlatformFreeBlock(void *ptr)
{
	DisposePtr((Ptr) ptr);
}

//----------------------------------------------------------------------------------------
// PlatformCopyMemory
//----------------------------------------------------------------------------------------

inline void PlatformCopyMemory(void *source, void *destination, size_t length)
{
	MABlockMove(source, destination, (Size) length);
}

#endif
